Package javax.media.j3d

# Class Billboard

java.lang.Object
javax.media.j3d.SceneGraphObject
javax.media.j3d.Node
javax.media.j3d.Leaf
javax.media.j3d.Behavior
javax.media.j3d.Billboard

public class Billboard extends Behavior
The Billboard behavior node operates on the TransformGroup node to cause the local +z axis of the TransformGroup to point at the viewer's eye position. This is done regardless of the transforms above the specified TransformGroup node in the scene graph.

If the alignment mode is ROTATE_ABOUT_AXIS, the rotation will be around the specified axis. If the alignment mode is ROTATE_ABOUT_POINT, the rotation will be about the specified point, with an additional rotation to align the +y axis of the TransformGroup with the +y axis in the View.

Note that in a multiple View system, the alignment is done to the primary View only.

Billboard nodes are ideal for drawing screen aligned-text or for drawing roughly-symmetrical objects. A typical use might consist of a quadrilateral that contains a texture of a tree.

See Also:
  - `OrientedShape3D`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ROTATE_ABOUT_AXIS`
Specifies that rotation should be about the specified axis.
`static final int`
`ROTATE_ABOUT_POINT`
Specifies that rotation should be about the specified point and that the children's Y-axis should match the view object's Y-axis.

### Fields inherited from class javax.media.j3d.Node

`ALLOW_AUTO_COMPUTE_BOUNDS_READ, ALLOW_AUTO_COMPUTE_BOUNDS_WRITE, ALLOW_BOUNDS_READ, ALLOW_BOUNDS_WRITE, ALLOW_COLLIDABLE_READ, ALLOW_COLLIDABLE_WRITE, ALLOW_LOCAL_TO_VWORLD_READ, ALLOW_LOCALE_READ, ALLOW_PARENT_READ, ALLOW_PICKABLE_READ, ALLOW_PICKABLE_WRITE, ENABLE_COLLISION_REPORTING, ENABLE_PICK_REPORTING`

## Constructor Summary

Constructors
Constructor
Description
`Billboard()`
Constructs a Billboard node with default parameters.
`Billboard(TransformGroup tg)`
Constructs a Billboard node with default parameters that operates on the specified TransformGroup node.
`Billboard(TransformGroup tg, int mode, javax.vecmath.Point3f point)`
Constructs a Billboard node with the specified rotation point and mode that operates on the specified TransformGroup node.
`Billboard(TransformGroup tg, int mode, javax.vecmath.Vector3f axis)`
Constructs a Billboard node with the specified axis and mode that operates on the specified TransformGroup node.

## Method Summary

Modifier and Type
Method
Description
`Node`
`cloneNode(boolean forceDuplicate)`
Creates a new instance of the node.
`void`
`getAlignmentAxis(javax.vecmath.Vector3f axis)`
Gets the alignment axis and sets the parameter to this value.
`int`
`getAlignmentMode()`
Gets the alignment mode.
`void`
`getRotationPoint(javax.vecmath.Point3f point)`
Gets the rotation point and sets the parameter to this value.
`TransformGroup`
`getTarget()`
Returns a copy of the transformGroup associated with this Billboard.
`void`
`initialize()`
Initialize method that sets up initial wakeup criteria.
`void`
`processStimulus(Enumeration criteria)`
Process stimulus method that computes appropriate transform.
`void`
`setAlignmentAxis(float x, float y, float z)`
Sets the alignment axis.
`void`
`setAlignmentAxis(javax.vecmath.Vector3f axis)`
Sets the alignment axis.
`void`
`setAlignmentMode(int mode)`
Sets the alignment mode.
`void`
`setRotationPoint(float x, float y, float z)`
Sets the rotation point.
`void`
`setRotationPoint(javax.vecmath.Point3f point)`
Sets the rotation point.
`void`
`setTarget(TransformGroup tg)`
Sets the tranformGroup for this Billboard object.
`void`
`updateNodeReferences(NodeReferenceTable referenceTable)`
Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`.

### Methods inherited from class javax.media.j3d.Behavior

`getEnable, getNumSchedulingIntervals, getSchedulingBoundingLeaf, getSchedulingBounds, getSchedulingInterval, getView, getWakeupCondition, postId, setEnable, setSchedulingBoundingLeaf, setSchedulingBounds, setSchedulingInterval, wakeupOn`

### Methods inherited from class javax.media.j3d.Node

`cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, cloneTree, duplicateNode, getBounds, getBoundsAutoCompute, getCollidable, getLocale, getLocalToVworld, getLocalToVworld, getParent, getPickable, setBounds, setBoundsAutoCompute, setCollidable, setPickable`

### Methods inherited from class javax.media.j3d.SceneGraphObject

`clearCapability, clearCapabilityIsFrequent, duplicateSceneGraphObject, getCapability, getCapabilityIsFrequent, getName, getUserData, isCompiled, isLive, setCapability, setCapabilityIsFrequent, setName, setUserData, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### ROTATE_ABOUT_AXIS

public static final int ROTATE_ABOUT_AXIS
Specifies that rotation should be about the specified axis.

See Also:
  - Constant Field Values

### ROTATE_ABOUT_POINT

public static final int ROTATE_ABOUT_POINT
Specifies that rotation should be about the specified point and that the children's Y-axis should match the view object's Y-axis.

See Also:
  - Constant Field Values

## Constructor Details

### Billboard

public Billboard()
Constructs a Billboard node with default parameters. The default values are as follows:

alignment mode : ROTATE_ABOUT_AXIS
alignment axis : Y-axis (0,1,0)
rotation point : (0,0,1)
target transform group: null

### Billboard

public Billboard(TransformGroup tg)
Constructs a Billboard node with default parameters that operates on the specified TransformGroup node. The default alignment mode is ROTATE_ABOUT_AXIS rotation with the axis pointing along the Y axis.

Parameters:
  `tg` - the TransformGroup node that this Billboard node operates upon

### Billboard

public Billboard(TransformGroup tg, int mode, javax.vecmath.Vector3f axis)
Constructs a Billboard node with the specified axis and mode that operates on the specified TransformGroup node. The specified axis must not be parallel to the Z axis--(0,0,z) for any value of z. It is not possible for the +Z axis to point at the viewer's eye position by rotating about itself. The target transform will be set to the identity if the axis is (0,0,z).

Parameters:
  `tg` - the TransformGroup node that this Billboard node operates upon
  `mode` - alignment mode, one of ROTATE_ABOUT_AXIS or ROTATE_ABOUT_POINT
  `axis` - the ray about which the billboard rotates

### Billboard

public Billboard(TransformGroup tg, int mode, javax.vecmath.Point3f point)
Constructs a Billboard node with the specified rotation point and mode that operates on the specified TransformGroup node.

Parameters:
  `tg` - the TransformGroup node that this Billboard node operates upon
  `mode` - alignment mode, one of ROTATE_ABOUT_AXIS or ROTATE_ABOUT_POINT
  `point` - the position about which the billboard rotates

## Method Details

### setAlignmentMode

public void setAlignmentMode(int mode)
Sets the alignment mode.

Parameters:
  `mode` - one of: ROTATE_ABOUT_AXIS or ROTATE_ABOUT_POINT

### getAlignmentMode

public int getAlignmentMode()
Gets the alignment mode.

Returns:
  one of: ROTATE_ABOUT_AXIS or ROTATE_ABOUT_POINT

### setAlignmentAxis

public void setAlignmentAxis(javax.vecmath.Vector3f axis)
Sets the alignment axis. The specified axis must not be parallel to the Z axis--(0,0,z) for any value of z. It is not possible for the +Z axis to point at the viewer's eye position by rotating about itself. The target transform will be set to the identity if the axis is (0,0,z).

Parameters:
  `axis` - the ray about which the billboard rotates

### setAlignmentAxis

public void setAlignmentAxis(float x, float y, float z)
Sets the alignment axis. The specified axis must not be parallel to the Z axis--(0,0,z) for any value of z. It is not possible for the +Z axis to point at the viewer's eye position by rotating about itself. The target transform will be set to the identity if the axis is (0,0,z).

Parameters:
  `x` - the x component of the ray about which the billboard rotates
  `y` - the y component of the ray about which the billboard rotates
  `z` - the z component of the ray about which the billboard rotates

### getAlignmentAxis

public void getAlignmentAxis(javax.vecmath.Vector3f axis)
Gets the alignment axis and sets the parameter to this value.

Parameters:
  `axis` - the vector that will contain the ray about which the billboard rotates

### setRotationPoint

public void setRotationPoint(javax.vecmath.Point3f point)
Sets the rotation point.

Parameters:
  `point` - the point about which the billboard rotates

### setRotationPoint

public void setRotationPoint(float x, float y, float z)
Sets the rotation point.

Parameters:
  `x` - the x component of the point about which the billboard rotates
  `y` - the y component of the point about which the billboard rotates
  `z` - the z component of the point about which the billboard rotates

### getRotationPoint

public void getRotationPoint(javax.vecmath.Point3f point)
Gets the rotation point and sets the parameter to this value.

Parameters:
  `point` - the position the Billboard rotates about

### setTarget

public void setTarget(TransformGroup tg)
Sets the tranformGroup for this Billboard object.

Parameters:
  `tg` - the transformGroup node which replaces the current transformGroup node for this Billboard

### getTarget

public TransformGroup getTarget()
Returns a copy of the transformGroup associated with this Billboard.

Returns:
  the TranformGroup for this Billboard

### initialize

public void initialize()
Initialize method that sets up initial wakeup criteria.

Specified by:
  `initialize` in class `Behavior`

### processStimulus

public void processStimulus(Enumeration criteria)
Process stimulus method that computes appropriate transform.

Specified by:
  `processStimulus` in class `Behavior`
Parameters:
  `criteria` - an enumeration of the criteria that caused the stimulus

### cloneNode

public Node cloneNode(boolean forceDuplicate)
Creates a new instance of the node. This routine is called by `cloneTree` to duplicate the current node.

Overrides:
  `cloneNode` in class `Node`
Parameters:
  `forceDuplicate` - when set to `true`, causes the `duplicateOnCloneTree` flag to be ignored. When `false`, the value of each node's `duplicateOnCloneTree` variable determines whether NodeComponent data is duplicated or copied.
See Also:
  - `Node.cloneTree()`
  - `Node.cloneNode(boolean)`
  - `Node.duplicateNode(javax.media.j3d.Node, boolean)`
  - `NodeComponent.setDuplicateOnCloneTree(boolean)`

### updateNodeReferences

public void updateNodeReferences(NodeReferenceTable referenceTable)
Callback used to allow a node to check if any scene graph objects referenced by that node have been duplicated via a call to `cloneTree`. This method is called by `cloneTree` after all nodes in the sub-graph have been duplicated. The cloned Leaf node's method will be called and the Leaf node can then look up any object references by using the `getNewObjectReference` method found in the `NodeReferenceTable` object. If a match is found, a reference to the corresponding object in the newly cloned sub-graph is returned. If no corresponding reference is found, either a DanglingReferenceException is thrown or a reference to the original object is returned depending on the value of the `allowDanglingReferences` parameter passed in the `cloneTree` call.

NOTE: Applications should not call this method directly. It should only be called by the cloneTree method.

Overrides:
  `updateNodeReferences` in class `Behavior`
Parameters:
  `referenceTable` - a NodeReferenceTableObject that contains the `getNewObjectReference` method needed to search for new object instances.
See Also:
  - `NodeReferenceTable`
  - `Node.cloneTree()`
  - `DanglingReferenceException`